<script>
    export let plot_element;
    export let data;
    export let xScale;
    export let yScale;
    import dayjs from "dayjs";
    import duration from "dayjs/plugin/duration";
    dayjs.extend(duration);

    let intervalWidth = 30 * 60 * 60;
    $: cadence = dayjs.duration(data.cadence).asMilliseconds();
    $: intervalWidth = xScale(cadence) - xScale(0);
    $: barOffset = 0.5 * plot_element.plot_options.bar_padding * intervalWidth;
    $: barWidth = intervalWidth * (1 - plot_element.plot_options.bar_padding);

    const fillColor = function (value) {
        var colorthresholds = plot_element.plot_options["fill_colors"];
        for (var i = 0; i < colorthresholds.length; i++) {
            var colorthreshold = colorthresholds[i];
            if (value < colorthreshold.threshold) {
                return colorthreshold.color;
            }
        }
        return "#888";
    };

    const strokeColor = function (value) {
        var colorthresholds = plot_element.plot_options["stroke_colors"];
        if (colorthresholds) {
            for (var i = 0; i < colorthresholds.length; i++) {
                var colorthreshold = colorthresholds[i];
                if (value < colorthreshold.threshold) {
                    return colorthreshold.color;
                }
            }
        }
        return "#000";
    };

    function kptext(kp) {
        let kpint = Math.trunc(kp);
        let kpdif = kp - kpint;
        if (kpdif < 0.1) {
            return kpint.toFixed(0);
        }
        if (kpdif > 0.2 && kpdif < 0.4) {
            return kpint.toFixed(0) + "+";
        }
        if (kpdif > 0.6 && kpdif < 0.9) {
            return (kpint + 1).toFixed(0) + "-";
        }
    }

    function text_y(value, yScale) {
        if (value > 7) {
            return yScale(value) + 15;
        } else {
            return yScale(value) - 4;
        }
    }

    function text_fill(value) {
        if (value <= 7) {
            return "bartext fill-black dark:fill-white";
        } else {
            return "bartext fill-white dark:fill-white";
        }
    }
</script>

{#each data.datalist as d}
    {#if !isNaN(d[plot_element.data.parameter])}
        <!-- Draw the bar -->
        <rect
            x={xScale(new Date(d.time)) + barOffset}
            y={yScale(d[plot_element.data.parameter])}
            width={barWidth}
            height={yScale(0) - yScale(d[plot_element.data.parameter])}
            fill={fillColor(d[plot_element.data.parameter])}
            fill-opacity={plot_element.plot_options["fill-opacity"]}
            stroke={strokeColor(d[plot_element.data.parameter])}
            stroke-opacity={plot_element.plot_options["stroke-opacity"]}
            stroke-width={plot_element.plot_options["stroke-width"]}>
            <title
                >{plot_element.title} [{plot_element.data.dataset} / {plot_element
                    .data.parameter}]
Value: {d[plot_element.data.parameter]}</title>
        </rect>

        <!-- Optional text annotation of the value, if the bar is wide enough -->
        {#if intervalWidth > 35 && plot_element.plot_options["bar_text"]}
            <text
                x={xScale(new Date(d.time)) + 0.5 * intervalWidth}
                y={text_y(d[plot_element.data.parameter], yScale)}
                class={text_fill(d[plot_element.data.parameter])}
                text-anchor="middle">
                {kptext(d[plot_element.data.parameter])}
            </text>
        {/if}
    {/if}
{/each}

<style>
    text.bartext {
        font-size: 11px;
    }
</style>
